<template>
  <div class="profile-modal-container">
    <div class="profile-modal">
      <div
        class="profile-container"
        v-if="selectedContact.avatarFileId"
        :style="{ 'background-image': 'url(' + avatarUrl + ')' }"
      >
        <div class="close-content">
          <ion-icon
            :icon="close"
            style="color: #fff; font-size: 30px; cursor: pointer"
            @click="closeModal"
          ></ion-icon>
        </div>
        <div class="info-content"></div>
      </div>
      <coreHeader width="100%" height="85px" v-else>
        <template #headerContent>
          <div class="header">
            <div class="info-container">
              <div class="avatar-circle" :class="[selectedContact.avatarClass]">
                {{ selectedContact.name[0] }}
              </div>
              <div class="info">
                <span class="name"> {{ selectedContact.name }} </span>
                <span class="status"> Online </span>
              </div>
            </div>
            <div class="close-container">
              <ion-icon
                :icon="close"
                style="color: #fff; font-size: 30px; cursor: pointer"
                @click="closeModal"
              ></ion-icon>
            </div>
          </div>
        </template>
      </coreHeader>
      <div class="content">
        {{ selectedContact.avatarFileId }}
      </div>
    </div>
  </div>
</template>

<script setup>
import { getFile } from '@/helpers/parser.js';
import { useFileManagerStore } from '@/store/fileManager/fileManager.js';
import { useThemeStore } from '@/store/theme.js';
import { IonIcon } from '@ionic/vue';
import { close } from 'ionicons/icons';
import coreHeader from '../coreHeader.vue';
import { computed, onMounted, ref } from 'vue';
import { useContactsStore } from '@/store/contacts/contacts.js';
import { useNestedModalsDesktop } from '@/store/nestedModals/nestedModalsDesktop.js';
import { useUserStore } from '@/store/user/user.js';

const nestedModalsDesktop = useNestedModalsDesktop();
const fileManagerStore = useFileManagerStore();
const themeStore = useThemeStore();
const contactStore = useContactsStore();
const userStore = useUserStore();
const avatarUrl = ref('');

const themeIsDark = computed(() => {
  return themeStore.getThemeIsDark;
});

const selectedContact = computed(() => {
  return contactStore.selectedConatct;
});

const closeModal = () => {
  nestedModalsDesktop.changeStatusContactProfile(false);
};

onMounted(async () => {
  const blob = await getFile(
    selectedContact.value.avatarFileId,
    userStore.token,
    'image',
  );
  avatarUrl.value = blob.filePath;
});
</script>

<style scoped>
@keyframes bg-animation {
  0% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}

@keyframes modal-animation {
  0% {
    margin-top: 800px;
  }
  100% {
    margin-top: 0;
  }
}
.profile-modal-container {
  position: fixed;
  width: 100%;
  height: 100vh;
  display: flex;
  justify-content: center;
  align-items: center;
  background: rgba(255, 255, 255, 0.1);
  backdrop-filter: blur(5px);
  -webkit-backdrop-filter: blur(5px);
  animation: 0.3 bg-animation;
}

.profile-modal {
  border-radius: 10px;
  overflow: hidden;
  width: 400px;
  position: absolute;
  z-index: 1;
  display: flex;
  flex-direction: column;
  animation: 0.4s modal-animation;
  border: 1px solid #dfdcdc;
}

.profile-container {
  width: 100%;
  height: 200px;
  background-position: cover;
  background-repeat: no-repeat;
  background-size: 100%;
}

.close-content {
  width: 100%;
  height: 80px;
  display: flex;
  align-items: center;
  justify-content: end;
  padding: 0 15px;
}

.info-content {
  width: 100%;
  height: 120px;
  display: flex;
  align-items: end;
  justify-content: end;
  padding: 0 15px;
}

.profile-modal-dark {
  background: #303030;
  border: none;
}

.profile-modal .header {
  height: 85px;
  display: flex;
  align-items: center;
  padding: 0 15px;
}

.avatar-circle {
  width: 60px;
  height: 60px;
  border-radius: 50%;
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;
  font-size: 22px;
  font-weight: 600;
}

.info-container {
  width: 80%;
  display: flex;
  align-items: center;
}

.close-container {
  width: 20%;
  display: flex;
  justify-content: end;
}

.info {
  display: flex;
  flex-direction: column;
  padding: 0 10px;
}

.info .name {
  font-size: 19px;
  font-style: normal;
  font-weight: 700;
  line-height: normal;
}

.info .status {
  font-size: 11px;
  font-style: normal;
  font-weight: 600;
  line-height: normal;
}

.content {
  width: 100%;
  color: #303030;
}
</style>
